DispatcherType (Servlet 4.0 API Documentation - Apache Tomcat 9.0.75)

Package javax.servlet

## Enum DispatcherType

- java.lang.Object
- - java.lang.Enum<DispatcherType>
  - - javax.servlet.DispatcherType

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<DispatcherType>`

      public enum DispatcherType
      extends java.lang.Enum<DispatcherType>

  Enumeration of dispatcher types. Used both to define filter mappings and by Servlets to determine why they were called.
  Since:
    Servlet 3.0

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `ASYNC` | `AsyncContext.dispatch()`, `AsyncContext.dispatch(String)` and `AsyncContext.addListener(AsyncListener, ServletRequest, ServletResponse)`
    `ERROR` | When the container has passed processing to the error handler mechanism such as a defined error page.
    `FORWARD` | `RequestDispatcher.forward(ServletRequest, ServletResponse)`
    `INCLUDE` | `RequestDispatcher.include(ServletRequest, ServletResponse)`
    `REQUEST` | Normal (non-dispatched) requests.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static DispatcherType` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static DispatcherType[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### FORWARD

          public static final DispatcherType FORWARD

      `RequestDispatcher.forward(ServletRequest, ServletResponse)`

    - #### INCLUDE

          public static final DispatcherType INCLUDE

      `RequestDispatcher.include(ServletRequest, ServletResponse)`

    - #### REQUEST

          public static final DispatcherType REQUEST

      Normal (non-dispatched) requests.

    - #### ASYNC

          public static final DispatcherType ASYNC

      `AsyncContext.dispatch()`, `AsyncContext.dispatch(String)` and `AsyncContext.addListener(AsyncListener, ServletRequest, ServletResponse)`

    - #### ERROR

          public static final DispatcherType ERROR

      When the container has passed processing to the error handler mechanism such as a defined error page.

  - ### Method Detail

    - #### values

          public static DispatcherType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (DispatcherType c : DispatcherType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static DispatcherType valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null